//Code by Luka Gabric
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, registry, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

/////////////////////////////////////////////////////
//Some examples of GUID, globally unique identifier//
/////////////////////////////////////////////////////
      {25892e17-80f6-415f-9c65-7395632f0223}
      {a53e98e4-0197-4513-be6d-49836e406aaa}
      {e33898de-6302-4756-8f0c-5f6c5218e02e}
      {3a768eea-cbda-4926-a82d-831cb89092aa}
      {cd171f7c-560d-4a62-8d65-16b87419a58c}
      {17084b40-08f5-4bcd-a739-c0d08c176bad}
      {d63a8ffd-bdac-498c-b861-a53e11989cef}
      {11cdd494-de5b-460e-9ddf-4e84bad6f596}
      {deb17e15-d47c-449f-b1b0-4d55247d153f}
      {30a7e1b3-e763-4789-a54d-fcc53dcf973a}
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////

   with TRegistry.Create do
   begin
      RootKey := HKEY_CLASSES_ROOT;
      Access := KEY_ALL_ACCESS;
      OpenKey('\CLSID',false);

      if KeyExists('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}') = True then
      begin
         ShowMessage('The key already exists!');
         Exit;
      end;

      CreateKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');
      if OpenKey('\CLSID\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}',false) then WriteString('','My Folder'); //Folder name
      CreateKey('DefaultIcon');
      CreateKey('InProcServer32');
      CreateKey('Shell\Open\Command');
      CreateKey('ShellEx\PropertySheetHandlers\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');
      CreateKey('ShellFolder');
      if OpenKey('\CLSID\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}\DefaultIcon',false) then WriteString('','c:\icon.ico'); //Folder icon
      if OpenKey('\CLSID\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}\InProcServer32',false) then
      begin
         WriteString('','shell32.dll');
         WriteString('ThreadingModel','Apartment');
      end;
      if OpenKey('\CLSID\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}\Shell\Open\Command',false) then WriteString('','explorer /root,c:\'); //On click -> open c:\ in Windows Explorer
      if OpenKey('\CLSID\{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}\ShellFolder',false) then WriteFloat('Attributes',0);

//Add to My Computer, else delete next two lines of code
      RootKey := HKEY_LOCAL_MACHINE;
      if OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\',false) then CreateKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');

//Add to Desktop, else delete next two lines of code
      RootKey := HKEY_LOCAL_MACHINE;
      if OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Desktop\NameSpace\',false) then CreateKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');

      Free;
   end;
   ShowMessage('OK! Now you must refresh your Desktop and My Computer!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   with TRegistry.Create do
   begin

      Access := KEY_ALL_ACCESS;
      RootKey := HKEY_CLASSES_ROOT;

      OpenKey('\CLSID',false);
      if KeyExists('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}') = False then
      begin
         ShowMessage('The key does not exist!');
         Exit;
      end;

      if OpenKey('\CLSID',false) then DeleteKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');

      RootKey := HKEY_LOCAL_MACHINE;

      OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\',false);
      if KeyExists('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}') = False then
      begin
         ShowMessage('The key does not exist!');
         Exit;
      end;

      if OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\',false) then DeleteKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');

      OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Desktop\NameSpace\',false);
      if KeyExists('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}') = False then
      begin
         ShowMessage('The key does not exist!');
         Exit;
      end;

      if OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Desktop\NameSpace\',false) then DeleteKey('{FD4DF9E0-E3DE-11CE-BFCF-ABCD1DE12345}');


   end;

   ShowMessage('OK! Now you must refresh your Desktop and My Computer!');

end;

end.
